SystemOrganization addCategory: #Project!

Object subclass: #DidaticStructure
	instanceVariableNames: 'id name creator ownerList visible topic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!DidaticStructure commentStamp: 'RFG 5/11/2013 13:53' prior: 0!
Mudar o nome dessa classe. It represents: Lecture U Group U Subject U Courses!

DidaticStructure subclass: #Course
	instanceVariableNames: 'subjectList userList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Course commentStamp: 'RFG 5/2/2013 11:43' prior: 0!
Represents a course in the system.!

!Course class methodsFor: 'instance creation' stamp: 'AP 5/12/2013 20:09'!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId
	"Creates a new DidaticStructure with an Id, named aString and the creator indicated by anUserId."
	
	| newCourse
	  aTopic
	  sys		 |
	
	newCourse := super newNamed: aName  withId: anId by: anUserId onTopic: aTopicId.
	
	newCourse userList isNil
		ifTrue: [newCourse userList: OrderedCollection new].
		
	newCourse subjectList isNil
		ifTrue: [newCourse subjectList: OrderedCollection new].
		
	sys := System create.
	aTopic := sys findTopic: aTopicId.
	aTopic addCourse: newCourse.
	^newCourse! !

!Course methodsFor: 'inclusion' stamp: 'AP 5/12/2013 21:06'!
addUser: Id
	"comment stating purpose of message"

	userList add: Id! !

!Course methodsFor: 'remotion' stamp: 'AP 5/12/2013 21:07'!
removeUser: Id.
	"Removes the user with the given ID."
	
	userList remove: Id! !

!Course methodsFor: 'accessing' stamp: 'RFG 5/11/2013 09:58'!
subjectList
	"Returns the list of subjects included in the course."

	^subjectList.! !

!Course methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:07'!
subjectList: aListOfIds
	"Sets the list of subjects included in the course."

	subjectList := aListOfIds.! !

!Course methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:36'!
userList
	"Returns the list of inscribed users."

	^userList.! !

!Course methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:07'!
userList: aListOfIds
	"Sets the list of inscribed users."

	userList := aListOfIds.! !

!DidaticStructure class methodsFor: 'instance creation' stamp: 'RFG 5/13/2013 12:21'!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId
	"Creates a new DidaticStructure with an Id, named aString and the creator indicated by anUserId."

	| newDidaticStructure |
	
	newDidaticStructure := self new.
	
	newDidaticStructure id: anId.
	newDidaticStructure name: aName.
	newDidaticStructure creator: anUserId.
	newDidaticStructure topic: aTopicId.
	newDidaticStructure visible: False. 
	
	newDidaticStructure ownerList isNil
		ifTrue: [newDidaticStructure ownerList: OrderedCollection new].
	
	^newDidaticStructure.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 08:03'!
creator
	"Returns the creator."

	^creator.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:08'!
creator: anId
	"Sets the ID of the creator."

	creator := anId.! !

!DidaticStructure methodsFor: 'remotion' stamp: 'RFG 5/11/2013 21:59'!
delete
	"Deletes the DidaticStructure"! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/13/2013 12:22'!
id
	"Returns the id."

	^id.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/13/2013 12:22'!
id: anID
	"Sets the id."
	
	id := anID.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/10/2013 18:13'!
name
	"Returns the name."

	^name.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/10/2013 18:14'!
name: aString
	"Sets the name."

	name := aString.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 08:07'!
ownerList
	"Returns the list of owners."

	^ownerList.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:08'!
ownerList: aListOfIds
	"Sets the list of owners."

	ownerList := aListOfIds.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 14:26'!
topic
	"Returns the topic."

	^topic.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 14:26'!
topic: aTopic
	"Sets the topic."

	topic := aTopic.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:01'!
visible
	"Returns whether the structure is visible or not by non-owners users"

	^visible.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:03'!
visible: boolean
	"Sets whether the structure is visible or not by non-owners users"

	visible := boolean.! !

DidaticStructure subclass: #Group
	instanceVariableNames: 'userList instructor subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Group commentStamp: 'RFG 5/9/2013 13:46' prior: 0!
Represents a group in the system. Set of students at inscribed in a subject with a instructor.!

!Group class methodsFor: 'instance creation' stamp: 'AP 5/12/2013 21:32'!
newNamed: aName withId: anId by: anUserId onSubject:  anSubjectId andInstructor: anInstructorId
	"Creates a new Group in a Subject and a instructor"
	
	| newGroup system topicId|
	system := System create.
	topicId := system findSubject: anSubjectId topic.
	newGroup := super newNamed: aName withId: anId by: anUserId onTopic: topicId.
	newGroup instructor: anInstructorId.
	newGroup subject: anSubjectId.
	
	newGroup userList isNil
		ifTrue: [newGroup subjectList: OrderedCollection new].
	
	! !

!Group methodsFor: 'remotion' stamp: 'AP 5/12/2013 21:09'!
deleteFrom: system
	"Removes a group from the system."

	| subjectTarget |
	
	userList do:[:user |
		user leaveGroup: Id onSystem: system.
		].
	subjectTarget := system findSubject: subject.
	subjectTarget groupList remove: Id.! !

!Group methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:10'!
instructor
	"Returns the group's instructor."

	^instructor.! !

!Group methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:09'!
instructor: anUserId
	"Sets the group's instructor."

	instructor := anUserId.! !

!Group methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:10'!
subject
	"Returns the group's subject."

	^subject.! !

!Group methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:09'!
subject: anSubjectId
	"Sets the group's subject."

	subject := anSubjectId.! !

!Group methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:54'!
userList
	"Returns the list of inscribed users."

	^userList.! !

!Group methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:09'!
userList: aListOfIds
	"Sets the list of inscribed users."

	userList := aListOfIds.! !

DidaticStructure subclass: #Lecture
	instanceVariableNames: 'subject userList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Lecture commentStamp: 'RFG 5/10/2013 18:02' prior: 0!
Represents a Lecture of a Subject!

!Lecture class methodsFor: 'instance creation' stamp: 'RFG 5/12/2013 17:06'!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId onSubject:  anSubjectId 
	"Creates a new Lecture in a Subject"

	| newLecture |
	
	newLecture := super newNamed: aName  withId: anId by: anUserId onTopic: aTopicId.
	newLecture subject: anSubjectId.
	
	newLecture userList isNil
		ifTrue: [newLecture subjectList: OrderedCollection new].! !

!Lecture methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:43'!
subject
	"Returns the lecture's subject."

	^subject.! !

!Lecture methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:10'!
subject: anSubjectId
	"Sets the lecture's subject."

	subject := anSubjectId.! !

!Lecture methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:43'!
userList
	"Returns the list of inscribed users."

	^userList.! !

!Lecture methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:10'!
userList: aListOfIds
	"Sets the list of inscribed users."

	userList := aListOfIds.! !

DidaticStructure subclass: #Subject
	instanceVariableNames: 'groupTable responsible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Subject commentStamp: 'RFG 5/6/2013 15:55' prior: 0!
Represents a Subject in the system.!

!Subject class methodsFor: 'instance creation' stamp: 'AP 5/13/2013 13:24'!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId

	"Creates a new Subject managed by a teacher responsible. "

	| newSubject 
	  topic
	  sys             |
	
	newSubject := super newNamed: aName withId: anId by: anUserId onTopic: aTopicId.
	
	newSubject groupTable isNil
		ifTrue: [newSubject groupTable: Dictionary new].
		
	sys := System create.
	
	topic := sys findTopic: aTopicId.
	topic addSubject: newSubject.
	
	^newSubject.! !

!Subject class methodsFor: 'instance creation' stamp: 'RFG 5/13/2013 13:14'!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId managedBy: responsibleId
	"Creates a new Subject managed by a teacher responsible. "

	| newSubject 
	  topic
	  sys             |
	
	newSubject := self newWithID: anId named: aName by: anUserId onTopic: aTopicId.
	newSubject responsible: responsibleId.
	
	newSubject groupTable isNil
		ifTrue: [newSubject subjectList: Dictionary new].
		
	sys := System create.
	
	topic := sys findTopic: aTopicId.
	topic addSubject: aTopicId.
	
	^newSubject.! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/12/2013 09:13'!
groupTable
	"Returns the table of groups that study this discipline."

	^groupTable.! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/12/2013 09:13'!
groupTable: aDict
	"Sets the table of groups that study this discipline."

	groupTable := aDict.! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/12/2013 09:14'!
responsible
	"Returns the teacher responsible for this subject."

	^responsible.! !

!Subject methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:11'!
responsible: anUserId
	"Sets the teacher responsible for this subject."

	responsible := anUserId.! !

DidaticStructure subclass: #Topic
	instanceVariableNames: 'courseTable subjectTable moderatorList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Topic commentStamp: 'RFG 5/2/2013 13:44' prior: 0!
Represents a topic in the system.!

!Topic class methodsFor: 'instance creation' stamp: 'AP 5/12/2013 19:53'!
newNamed: aName withId: anId by: anUserId
	"Creates a new topic with the given name and id."
	
	|newTopic
	 sys		|
	
	newTopic := super newNamed: aName withId: anId by: anUserId onTopic: anId .
	
	newTopic courseTable isNil
		ifTrue: [newTopic courseTable: Dictionary new].
		
	newTopic subjectTable isNil
		ifTrue: [newTopic subjectTable: Dictionary new].
	
	newTopic moderatorList isNil
		ifTrue: [newTopic moderatorList: OrderedCollection new].
		
	sys := System create.
	sys addTopic: newTopic.
	
	^newTopic.! !

!Topic methodsFor: 'adding' stamp: 'AP 5/11/2013 23:34'!
addCourse: aCourse

	courseTable at: aCourse id put: aCourse.

	! !

!Topic methodsFor: 'adding' stamp: 'AP 5/12/2013 20:54'!
addModerator: aModeratorId

	moderatorList add: aModeratorId.! !

!Topic methodsFor: 'adding' stamp: 'RFG 5/13/2013 13:09'!
addSubject: aSubject
	"Adds the subject to the subject list."

	subjectTable at: aSubject id put: aSubject.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:16'!
courseTable
	"Returns the dictionary of courses of the topic."

	^courseTable.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:17'!
courseTable: aDictionary
	"Sets the dictionary of courses of the topic."

	courseTable := aDictionary.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/5/2013 08:50'!
creator
	"Returns the topic creator."

	^creator.! !

!Topic methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:28'!
creator: anUserId.
	"Sets the topic creator."

	creator := anUserId.! !

!Topic methodsFor: 'accessing' stamp: 'AP 5/12/2013 15:25'!
findCourse: aCourseId

	^courseTable at: aCourseId ifAbsent:[^nil].! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/13/2013 12:55'!
id
	"Returns the topic id."

	^id.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/13/2013 12:56'!
id: anId
	"Sets the topic id."

	id := anId.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:44'!
moderatorList
	"Returns the list of moderators of the topic."

	^moderatorList.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:43'!
moderatorList: anOrderedCollection
	"Sets the list of moderators of the topic."

	moderatorList := anOrderedCollection.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:15'!
name
	"Returns the topic name."

	^name.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:15'!
name: aName.
	"Sets the topic name."

	name := aName.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:42'!
subjectTable
	"Returns the dictionary of subjects of the topic."

	^subjectTable.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:41'!
subjectTable: aDictionary
	"Sets the dictionary of subjects of the topic."

	subjectTable := aDictionary.! !

Object subclass: #System
	instanceVariableNames: ''
	classVariableNames: 'TopicTable TopicToBeAproved Tst4 UserTable'
	poolDictionaries: ''
	category: 'Project'!

!System commentStamp: 'RFG 5/2/2013 13:21' prior: 0!
The main class representing the own system.!

!System class methodsFor: 'initialization' stamp: 'AP 5/12/2013 20:10'!
create
	"Creates an empty system."
	
	Tst4 isNil
		ifTrue: [
			Tst4 := self new.
			TopicTable := Dictionary new.
			UserTable := Dictionary new.
			TopicToBeAproved := OrderedCollection new.
			].
		^Tst4.! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:54'!
TopicTable
	"Returns the dictionary with all topics."

	^TopicTable.! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:54'!
TopicTable: aDictionary
	"Sets the dictionary with all topics."

	TopicTable :=  aDictionary! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:17'!
UserTable
	"Returns the dictionary with all users."

	^UserTable.! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:13'!
UserTable: aDictionary
	"Sets the system user table."

	UserTable := aDictionary.! !

!System methodsFor: 'adding' stamp: 'RFG 5/13/2013 13:03'!
addTopic: aTopic

	TopicTable at: aTopic id put: aTopic.
	TopicToBeAproved addLast: aTopic id.! !

!System methodsFor: 'adding' stamp: 'RFG 5/13/2013 13:03'!
addUser: anUser

	UserTable at: anUser id put: anUser  .! !

!System methodsFor: 'accessing' stamp: 'RFG 5/12/2013 16:15'!
findCoursE: Id
	"Returns a group with the given ID."
	
	|isThere|
	TopicTable do:  [:topic | 
		isThere := topic courseTable includesKey: Id.
		isThere ifTrue:[^topic courseTable at: Id]
		].
	self errorKeyNotFound: Id.! !

!System methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:13'!
findCourse: Id
	"Returns a course with the given ID."
	
	| anArray
	  aTopic
	  aCourse
	  index   |
	
	index := 1.
	anArray := TopicTable associations.
	[index <= anArray size]
	whileTrue: [
		aTopic := anArray at: index.
		aCourse := aTopic value findCourse: Id.
		aCourse notNil
		ifTrue:[
			^aCourse
			].
		index := index +1
		]! !

!System methodsFor: 'accessing' stamp: 'RFG 5/13/2013 12:47'!
findGroup: Id
	"Returns a group with the given ID."
	
	|isThere|
	TopicTable do:  [:topic |
		topic subjectTable do: [:subject |
			isThere := subject groupTable includesKey: Id.
			isThere ifTrue:[
				^subject groupTable at: Id]
		].
	].
	self errorKeyNotFound: Id.
	! !

!System methodsFor: 'accessing' stamp: 'RFG 5/12/2013 10:35'!
findSubject: ID
	"Returns a subject with the given ID."
	
	| subject |
	subject := TopicTable keysAndValuesDo:  [:topicID :topic | 
		topic courseTable at: ID ifAbsent:[].
			].
	subject isNil ifTrue:  [self errorKeyNotFound: ID] 
				ifFalse: [^subject].! !

!System methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:13'!
findTopic: anId

	^TopicTable at: anId! !

!System methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:13'!
findUser: anId

	^UserTable at: anId! !

!System methodsFor: 'removing' stamp: 'AP 5/12/2013 21:27'!
removeTopic: anId
	"Remove a Topic from the System"
	TopicTable removeKey: anId! !

!System methodsFor: 'removing' stamp: 'AP 5/12/2013 21:27'!
removeUser: anId
	"Remove an user from the System"
	UserTable removeKey: anId! !

!System methodsFor: 'accessing' stamp: 'AP 5/11/2013 21:53'!
topicToModerator
	"Gives a topic for the moderator analysis"
	^TopicToBeAproved at: 1! !

Object subclass: #User
	instanceVariableNames: 'id name courseList groupList contentList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!User commentStamp: 'RFG 5/2/2013 11:22' prior: 0!
Represents a user in the system.!

User subclass: #Moderator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Moderator commentStamp: 'RFG 5/11/2013 12:24' prior: 0!
Represents a topic moderator in the system.!

Moderator subclass: #Administrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Administrator commentStamp: 'RFG 5/11/2013 14:52' prior: 0!
Represents special users who can create topics and erase/create anything.!

!Administrator methodsFor: 'creation' stamp: 'RFG 5/13/2013 12:38'!
createTopic: aName withId: anId by: userId

	| sys
	  aTopic|
	
	aTopic := Topic  newNamed: aName withId: anId by: userId.
	sys := System create.
	sys addTopic: aTopic.! !

!Administrator methodsFor: 'creation' stamp: 'AP 5/12/2013 20:38'!
createTopic: aName withId: anId created: userId

	| sys
	  aTopic|
	
	aTopic := Topic  newNamed: aName withId: anId by: userId.
	sys := System create.
	sys addTopic: aTopic.! !

!Administrator methodsFor: 'creation' stamp: 'AP 5/12/2013 21:06'!
createUser: aName withId: anId
	
	| newUser 
	  sys    |
	
	newUser := User newNamed: aName withId: anId.
	sys := System create.
	sys addUser: newUser.! !

!Administrator methodsFor: 'nominate' stamp: 'AP 5/13/2013 13:38'!
nominateAdministrator: anUser
	"Give moderator privileges to an user"

	| newAdministrator
	  sys			      |
	
	newAdministrator := Administrator newNamed: anUser name withId: anUser id.
	newAdministrator courseList: anUser courseList. 
	newAdministrator groupList: anUser groupList.
	newAdministrator contentList: anUser contentList.
	
	sys := System create.
	sys removeUser: anUser id.
	sys addUser: newAdministrator id.! !

!Administrator methodsFor: 'nominate' stamp: 'AP 5/13/2013 13:36'!
nominateModerator: anUser onTopic: aTopicId
	"Give moderator privileges to an user"

	| newModerator 
	  sys			
	  aTopic		|
	
	newModerator := Moderator newNamed: anUser name withId: anUser id.
	newModerator courseList: anUser courseList. 
	newModerator groupList: anUser groupList.
	newModerator contentList: anUser contentList.
	
	sys := System create.
	sys removeUser: anUser id.
	sys addUser: newModerator.
	
	aTopic := sys findTopic: aTopicId.
	aTopic addModerator: newModerator id.! !

!Moderator methodsFor: 'publishing' stamp: 'AP 5/11/2013 21:55'!
aproveTopic
	"Make a topic visible for the public. In other words, the moderator aproves a topic
	using this function"
	| anId
	  aTopic
	  sys	|
	
	sys := System create.
	anId := sys topicToModerator.
	aTopic := sys findTopic: anId.
	aTopic visible: true.
! !

!Moderator methodsFor: 'publishing' stamp: 'RFG 5/12/2013 10:56'!
hide: aDidaticStructure
	"Turns a didatic structure invisible to all commom users non-owners."

	| topic system |
	
	system := System create.
	topic :=  system findTopic: aDidaticStructure topic.
	
	id in topic moderatorList
		ifTrue: [aDidaticStructure visible: False].
		! !

!Moderator methodsFor: 'publishing' stamp: 'RFG 5/12/2013 10:57'!
publish: aDidaticStructure
	"Turns a didatic structure invisible to all commom users non-owners."

	| topic system |
	
	system := System create.
	topic :=  system findTopic: aDidaticStructure topic.
	
	id in topic moderatorList
		ifTrue: [aDidaticStructure visible: True].
		! !

!User class methodsFor: 'instance creation' stamp: 'AP 5/12/2013 19:58'!
newNamed: aName withId: anId
	"comment stating purpose of message"
	
	|newUser
	 sys	   |
		
	newUser := self new.
	newUser id: anId.
	newUser name: aName.
	newUser groupList isNil
		ifTrue: [newUser groupList: OrderedCollection new].
	newUser courseList isNil
		ifTrue: [newUser courseList: OrderedCollection new].
	newUser contentList isNil
		ifTrue: [newUser contentList: OrderedCollection new].
		
	sys := System create.
	sys addUser: newUser.
	^newUser! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 16:31'!
contentList
	"Returns a list with the IDs of the Contents owned by the user."

	^contentList.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 18:15'!
contentList: anOrderedCollection
	"Sets the user content list."

	contentList := anOrderedCollection.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 16:39'!
courseList
	"comment stating purpose of message"

	^courseList.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 18:19'!
courseList: anOrderedCollection
	"Sets the user content list."

	courseList := anOrderedCollection.! !

!User methodsFor: 'remotion' stamp: 'AP 5/11/2013 22:02'!
delete
	"Removes the user from the system."
	
	| sys |
	sys := System create.
	sys  removeUser: self Id.! !

!User methodsFor: 'remotion' stamp: 'RFG 5/12/2013 08:25'!
delete: aDidaticStructure
	"Tries to delete a structure."

	aDidaticStructure ownerList remove: id ifAbsent: [Transcript show: 'User can not do that.'].
	aDidaticStructure delete.! !

!User methodsFor: 'subscription' stamp: 'AP 5/12/2013 21:29'!
enrollCourse: courseId
	"Enrolls the user in a course and register this user in the courselist."
	
	| sys
	  aCourse |
	
	self courseList add: courseId.
	sys := System create.
	aCourse := sys findCourse: courseId.
	aCourse addUser: self Id.! !

!User methodsFor: 'subscription' stamp: 'AP 5/12/2013 21:30'!
enterGroup: aGroupId
	"Makes the user part of the group with the given ID."! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 16:30'!
groupList
	"Returns a list with the IDs of the Groups which the user is in."

	^groupList.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 18:16'!
groupList: anOrderedCollection
	"Sets the user group list."

	groupList := anOrderedCollection.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/13/2013 13:00'!
id
	"Returns the user ID."

	^id.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/13/2013 13:01'!
id: anId
	"comment stating purpose of message"

	id := anId.! !

!User methodsFor: 'subscription' stamp: 'AP 5/12/2013 21:31'!
leaveGroup: aGroupId
	"comment stating purpose of message"
	
	| group  system |
	system := System create.
	group := system findGroup: aGroupId. 
	group removeUser: Id.
	groupList remove: aGroupId.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 15:32'!
name
	"Returns the user's name."

	^name.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 15:17'!
name: aName
	"comment stating purpose of message"

	name := aName.! !

!User methodsFor: 'subscription' stamp: 'AP 5/12/2013 21:31'!
withdrawCourse: aCourseId
	"comment stating purpose of message"
	
	| course system|
	system := System create.
	course := system findCourse: aCourseId. 
	course userList remove: Id.
	courseList remove: aCourseId.! !
